#include "SDL/SDL.h"   //Including the SDL header files
#include "SDL/SDL_image.h"
#include "SDL/SDL_ttf.h"
#include <string>
#include <cmath>
using namespace std;
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
const int SCREEN_BPP = 32;
SDL_Surface *screen = NULL; //Initializing the SDL pointer variables
SDL_Surface* MainScr = NULL;
SDL_Surface* NumPlayers = NULL;
SDL_Surface* nameInputBck = NULL;
SDL_Surface* message = NULL;
SDL_Event event;
TTF_Font *font = NULL;
SDL_Color textColor = { 0xFF, 0xFF, 0xFF };
struct CompMove
{
    int x;
    int y;
    double Ratio;
};
void BlitBalls(int id, int quant,int xx,int yy,int G[][6][2]);
bool PlayerDetails(int a);
int NumberOfPlayer();
bool init()
{
    //Initialize all SDL subsystems
    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return false;
    }

    //Setting up the screen
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );

    //If there was an error in setting up the screen
    if( screen == NULL )
    {
        return false;
    }

    //Setting the window caption
    SDL_WM_SetCaption( "CHAIN REACTION", NULL );

    //If everything is correctly initialized
    return true;
}

SDL_Surface *load_image( std::string filename )
{
    //The image that's loaded
    SDL_Surface* loadedImage = NULL;

    //The optimized surface that will be used
    SDL_Surface* optimizedImage = NULL;

    //Load the image
    loadedImage = IMG_Load( filename.c_str() );

    //If the image loaded
    if( loadedImage != NULL )
    {
        //Create an optimized surface
        optimizedImage = SDL_DisplayFormat( loadedImage );

        //Free the old surface
        SDL_FreeSurface( loadedImage );

        //If the surface was optimized
        if( optimizedImage != NULL )
        {
            //Color key surface
            SDL_SetColorKey( optimizedImage, SDL_SRCCOLORKEY, SDL_MapRGB( optimizedImage->format, 0, 0xFF, 0xFF ) );
        }
    }

    //Return the optimized surface
    return optimizedImage;
}
void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination, SDL_Rect* clip = NULL )
{
    //Holds offsets
    SDL_Rect offset;

    //Get offsets
    offset.x = x;
    offset.y = y;

    //Blit
    SDL_BlitSurface( source, clip, destination, &offset );
}

bool checkPlayerExist(int J, int g[][6][2]) //Checking if the ID of a player exists on the grid
{
    for(int v=0; v<8;v++)
    {
        for(int h =0 ; h<6; h++)
        {
            if(J==g[v][h][1])
                return true;
        }
    }

return false;
}

int LocationType(int xx , int yy) //For finding if the square selected is a corner, and edge or an interior square
{
    if(((xx==0)&&(yy==0))||((xx==0)&&(yy==5))||((xx==7)&&(yy==0))||((xx==7)&&(yy==5)))
        return 0;
    if(((xx==0)&&(yy!=0))||((xx!=0)&&(yy==0))||((xx==7)&&(yy!=0))||((xx!=0)&&(yy==5)))
        return 1;
    return 2;
}
void Blast(int x , int y, int Gr[][6][2] , int ii) //To check the if the critical mass of each square has been reached
{
int Loc = LocationType(x,y);
if(Loc==0)
{
    if((Gr[x][y][0]/Gr[x][y][1])==2)
    {
        if ((x==0)&&(y==0))
        {
        if(Gr[1][0][1]!=0)
            {
                Gr[1][0][0] = ((Gr[1][0][0]/Gr[1][0][1])+1)*ii;
                Gr[1][0][1]=ii;
            }
        else
            Gr[1][0][0]=Gr[1][0][1]=ii;
        if(Gr[0][1][1]!=0)
            {
                Gr[0][1][0] = ((Gr[0][1][0]/Gr[0][1][1])+1)*ii;
                Gr[0][1][1]=ii;
            }
        else
            Gr[0][1][0]=Gr[0][1][1]=ii;
        Gr[0][0][0]=0;
        Gr[0][0][1]=0;
        if(!(ii>6))
        {
            SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60)+10,(x*60)+12,hide,screen);
        }
        Blast(0,1,Gr,ii);
        Blast(1,0,Gr,ii);
        }

        if ((x==0)&&(y==5))
        {
        if(Gr[0][4][1]!=0)
            {
                Gr[0][4][0] = ((Gr[0][4][0]/Gr[0][4][1])+1)*ii;
                Gr[0][4][1]=ii;
            }
        else
            Gr[0][4][0]=Gr[0][4][1]=ii;
        if(Gr[1][5][1]!=0)
            {
                Gr[1][5][0] = ((Gr[1][5][0]/Gr[1][5][1])+1)*ii;
                Gr[1][5][1]=ii;
            }
        else
            Gr[1][5][0]=Gr[1][5][1]=ii;
        Gr[0][5][0]=0;
        Gr[0][5][1]=0;
        if(!(ii>6))
        {
            SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60)+10,(x*60)+12,hide,screen);
        }
        Blast(0,4,Gr,ii);
        Blast(1,5,Gr,ii);
        }

        if ((x==7)&&(y==0))
        {
        if(Gr[6][0][1]!=0)
            {
                Gr[6][0][0] = ((Gr[6][0][0]/Gr[6][0][1])+1)*ii;
                Gr[6][0][1]=ii;
            }
        else
            Gr[6][0][0]=Gr[6][0][1]=ii;
        if(Gr[7][1][1]!=0)
            {
                Gr[7][1][0] = ((Gr[7][1][0]/Gr[7][1][1])+1)*ii;
                Gr[7][1][1]=ii;
            }
        else
            Gr[7][1][0]=Gr[7][1][1]=ii;
            Gr[7][0][0]=0;
        Gr[7][0][1]=0;
           if(!(ii>6))
           {
               SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60)+10,(x*60)+12,hide,screen);
           }
        Blast(6,0,Gr,ii);
        Blast(7,1,Gr,ii);
        }

        if ((x==7)&&(y==5))
        {
        if(Gr[7][4][1]!=0)
            {
                Gr[7][4][0] = ((Gr[7][4][0]/Gr[7][4][1])+1)*ii;
                Gr[7][4][1]=ii;
            }
        else
            Gr[7][4][0]=Gr[7][4][1]=ii;
        if(Gr[6][5][1]!=0)
            {
                Gr[6][5][0] = ((Gr[6][5][0]/Gr[6][5][1])+1)*ii;
                Gr[6][5][1]=ii;
            }
        else
            Gr[6][5][0]=Gr[6][5][1]=ii;
            Gr[7][5][0]=0;
        Gr[7][5][1]=0;
            if(!(ii>6))
            {
                SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60+10),(x*60+12),hide,screen);
            }
        Blast(6,5,Gr,ii);
        Blast(7,4,Gr,ii);
        }
        }
        else
        {
            if(!(ii>6))
            BlitBalls(ii,(Gr[x][y][0]/Gr[x][y][1]),y*60,x*60,Gr);
            return;
        }
}
else if(Loc==1)
{
    if((Gr[x][y][0]/Gr[x][y][1])==3)
    {
        if(y==0)
        {   if(Gr[x-1][0][1]!=0)
            {
                Gr[x-1][0][0] = ((Gr[x-1][0][0]/Gr[x-1][0][1])+1)*ii;
                Gr[x-1][0][1] = ii;
            }
        else
            Gr[x-1][0][0]=Gr[x-1][0][1]=ii;


            if(Gr[x+1][0][1]!=0)
            {
                Gr[x+1][0][0] = ((Gr[x+1][0][0]/Gr[x+1][0][1])+1)*ii;
                Gr[x+1][0][1] = ii;
            }
        else
            Gr[x+1][0][0]=Gr[x+1][0][1]=ii;

            if(Gr[x][1][1]!=0)
            {
                Gr[x][1][0] = ((Gr[x][1][0]/Gr[x][1][1])+1)*ii;
                Gr[x][1][1] = ii;
            }
        else
            Gr[x][1][0]=Gr[x][1][1]=ii;
            Gr[x][0][0]=0;
        Gr[x][0][1]=0;
        if(!(ii>6))
        {
            SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60+10),(x*60+12),hide,screen);
        }
            Blast(x-1,0,Gr,ii);
            Blast(x+1,0,Gr,ii);
            Blast(x,1,Gr,ii);
        }
        else if(x==0)
        {
           if(Gr[0][y-1][1]!=0)
            {
                Gr[0][y-1][0]=((Gr[0][y-1][0]/Gr[0][y-1][1])+1)*ii;
                Gr[0][y-1][1]=ii;
            }
        else
            Gr[0][y-1][0]=Gr[0][y-1][1]=ii;

            if(Gr[0][y+1][1]!=0)
            {
                Gr[0][y+1][0]=((Gr[0][y+1][0]/Gr[0][y+1][1])+1)*ii;
                Gr[0][y+1][1]=ii;
            }
        else
            Gr[0][y+1][0]=Gr[0][y+1][1]=ii;

            if(Gr[1][y][1]!=0)
            {
                Gr[1][y][0]=((Gr[1][y][0]/Gr[1][y][1])+1)*ii;
                Gr[1][y][1]=ii;
            }
        else
            Gr[1][y][0]=Gr[1][y][1]=ii;
            Gr[0][y][0]=0;
        Gr[0][y][1]=0;
         if(!(ii>6))
         {
             SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60+10),(x*60+12),hide,screen);
         }
            Blast(0,y-1,Gr,ii);
            Blast(0,y+1,Gr,ii);
            Blast(1,y,Gr,ii);
        }
        else if(x==7)
        {
        if(Gr[7][y-1][1]!=0)
             {
                Gr[7][y-1][0]=((Gr[7][y-1][0]/Gr[7][y-1][1])+1)*ii;
                Gr[7][y-1][1]=ii;
            }
        else
            Gr[7][y-1][0]=Gr[7][y-1][1]=ii;

            if(Gr[7][y+1][1]!=0)
             {
                Gr[7][y+1][0]=((Gr[7][y+1][0]/Gr[7][y+1][1])+1)*ii;
                Gr[7][y+1][1]=ii;
            }
        else
            Gr[7][y+1][0]=Gr[7][y+1][1]=ii;

            if(Gr[6][y][1]!=0)
             {
                Gr[6][y][0]=((Gr[6][y][0]/Gr[6][y][1])+1)*ii;
                Gr[6][y][1]=ii;
            }
        else
            Gr[6][y][0]=Gr[6][y][1]=ii;
            Gr[7][y][0]=0;
        Gr[7][y][1]=0;
          if(!(ii>6))
          {
              SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60+10),(x*60+12),hide,screen);
          }
            Blast(7,y-1,Gr,ii);
            Blast(7,y+1,Gr,ii);
            Blast(6,y,Gr,ii);
        }
        else
        {
            if(Gr[x-1][5][1]!=0)
             {
                Gr[x-1][5][0]=((Gr[x-1][5][0]/Gr[x-1][5][1])+1)*ii;
                Gr[x-1][5][1]=ii;
            }
        else
            Gr[x-1][5][0]=Gr[x-1][5][1]=ii;

            if(Gr[x+1][5][1]!=0)
             {
                Gr[x+1][5][0]=((Gr[x+1][5][0]/Gr[x+1][5][1])+1)*ii;
                Gr[x+1][5][1]=ii;
            }
        else
            Gr[x+1][5][0]=Gr[x+1][5][1]=ii;

            if(Gr[x][4][1]!=0)
           {
                Gr[x][4][0]=((Gr[x][4][0]/Gr[x][4][1])+1)*ii;
                Gr[x][4][1]=ii;
            }
        else
            Gr[x][4][0]=Gr[x][4][1]=ii;
            Gr[x][5][0]=0;
        Gr[x][5][1]=0;
           if(!(ii>6))
           {
               SDL_Surface* hide = load_image("hide.png");
            apply_surface((y*60+10),(x*60+12),hide,screen);
           }
            Blast(x-1,5,Gr,ii);
            Blast(x+1,5,Gr,ii);
            Blast(x,4,Gr,ii);
        }
    }
    else
    {
        if(!(ii>6))
        BlitBalls(ii,(Gr[x][y][0]/Gr[x][y][1]),y*60,x*60,Gr);
        return;
    }
}
else
{
 if((Gr[x][y][0]/Gr[x][y][1])==4)
    {
        if(Gr[x-1][y][1]!=0)
            {
                Gr[x-1][y][0]=((Gr[x-1][y][0]/Gr[x-1][y][1])+1)*ii;
                Gr[x-1][y][1]=ii;
            }
        else
            Gr[x-1][y][0]=Gr[x-1][y][1]=ii;

        if(Gr[x+1][y][1]!=0)
            {
                Gr[x+1][y][0]=((Gr[x+1][y][0]/Gr[x+1][y][1])+1)*ii;
                Gr[x+1][y][1]=ii;
            }
        else
            Gr[x+1][y][0]=Gr[x+1][y][1]=ii;

        if(Gr[x][y-1][1]!=0)
            {
                Gr[x][y-1][0]=((Gr[x][y-1][0]/Gr[x][y-1][1])+1)*ii;
                Gr[x][y-1][1]=ii;
            }
        else
            Gr[x][y-1][0]=Gr[x][y-1][1]=ii;

            if(Gr[x][y+1][1]!=0)
            {
                Gr[x][y+1][0]=((Gr[x][y+1][0]/Gr[x][y+1][1])+1)*ii;
                Gr[x][y+1][1]=ii;
            }
        else
            Gr[x][y+1][0]=Gr[x][y+1][1]=ii;
            Gr[x][y][0]=0;
        Gr[x][y][1]=0;
        if(!(ii>6))
            {
                SDL_Surface* hide = load_image("hide.png");
                apply_surface((y*60)+10,(x*60)+12,hide,screen);
            }
    Blast(x-1,y,Gr,ii);
    Blast(x,y-1,Gr,ii);
    Blast(x+1,y,Gr,ii);
    Blast(x,y+1,Gr,ii);
    }
else
{
    if(!(ii>6))
    BlitBalls(ii,(Gr[x][y][0]/Gr[x][y][1]),y*60,x*60,Gr);
    return;
}
}
}

void BlitBalls(int id, int quant,int xx,int yy,int G[][6][2]) //To print the balls on the screen
{
    switch(id)
    {
    case 1:
        {
            switch(quant)
            {
            case 1:
                {
                   SDL_Surface* one1 = load_image("one1.png");
                   apply_surface(xx+10,yy+12,one1,screen);
                   SDL_Flip(screen);
                   break;
                }
            case 2:
                {
                   SDL_Surface* one2 = load_image("one2.png");
                   apply_surface(xx+10,yy+12,one2,screen);
                   SDL_Flip(screen);
                   break;
                }
            case 3:
                {
                   SDL_Surface* one3 = load_image("one3.png");
                   apply_surface(xx+10,yy+12,one3,screen);
                   SDL_Flip(screen);
                   break;
                }
            case 4:
                {

                }
            }
            break;
        }
    case 2:
        {
            switch(quant)
            {
            case 1:
                {
                    SDL_Surface* two1 = load_image("two1.png");
                   apply_surface(xx+10,yy+12,two1,screen);
                    SDL_Flip(screen);
                    break;
                }
            case 2:
                {
                    SDL_Surface* two2 = load_image("two2.png");
                   apply_surface(xx+10,yy+12,two2,screen);
                    SDL_Flip(screen);
                    break;
                }
            case 3:
                {
                    SDL_Surface* two3 = load_image("two3.png");
                   apply_surface(xx+10,yy+12,two3,screen);
                    SDL_Flip(screen);
                    break;
                }
            case 4:
                {

                }
            }
            break;
        }
    case 3:
        {
            switch(quant)
            {
            case 1:
                {
                    SDL_Surface* three1 = load_image("three1.png");
                   apply_surface(xx+10,yy+12,three1,screen);
                    SDL_Flip(screen);
                    break;
                }
            case 2:
                {
                    SDL_Surface* three2 = load_image("three2.png");
                   apply_surface(xx+10,yy+12,three2,screen);
                 SDL_Flip(screen);
                    break;
                }
            case 3:
                {
                    SDL_Surface* three3 = load_image("three3.png");
                   apply_surface(xx+10,yy+12,three3,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 4:
                {

                }
            }
            break;
        }
    case 4:
        {
            switch(quant)
            {
            case 1:
                {
                    SDL_Surface* four1 = load_image("four1.png");
                   apply_surface(xx+10,yy+12,four1,screen);
                 SDL_Flip(screen);
                    break;
                }
            case 2:
                {
                    SDL_Surface* four2 = load_image("four2.png");
                   apply_surface(xx+10,yy+12,four2,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 3:
                {
                    SDL_Surface* four3 = load_image("four3.png");
                   apply_surface(xx+10,yy+12,four3,screen);
                  SDL_Flip(screen);
                    break;
                }
            case 4:
                {

                    break;
                }
            }
            break;
        }
    case 5:
        {
            switch(quant)
            {
            case 1:
                {
                    SDL_Surface* five1 = load_image("five1.png");
                   apply_surface(xx+10,yy+12,five1,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 2:
                {
                    SDL_Surface* five2 = load_image("five2.png");
                   apply_surface(xx+10,yy+12,five2,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 3:
                {
                    SDL_Surface* five3 = load_image("five3.png");
                   apply_surface(xx+10,yy+12,five3,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 4:
                {

                    break;
                }
            }
            break;
        }
    case 6:
        {
            switch(quant)
            {
            case 1:
                {
                    SDL_Surface* six1 = load_image("six1.png");
                   apply_surface(xx+10,yy+12,six1,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 2:
                {
                    SDL_Surface* six2 = load_image("six2.png");
                   apply_surface(xx+10,yy+12,six2,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 3:
                {
                    SDL_Surface* six3 = load_image("six3.png");
                   apply_surface(xx+10,yy+12,six3,screen);
                   SDL_Flip(screen);
                    break;
                }
            case 4:
                {
                    break;
                }
            }
            break;
        }
    }
}
void GameOver(int ID) // Flashes the Winning message
{
    //SDL_FreeSurface
    SDL_Surface* winMsg = NULL;
    switch(ID)
    {
    case 1:
         winMsg = load_image("winMsg1.png");
         break;
    case 2:
         winMsg = load_image("winMsg2.png");
         break;
    case 3:
         winMsg = load_image("winMsg3.png");
         break;
    case 4:
         winMsg = load_image("winMsg4.png");
         break;
    case 5:
         winMsg = load_image("winMsg5.png");
         break;
    case 6:
         winMsg = load_image("winMsg6.png");
         break;
    }
    apply_surface(0,0,winMsg,screen);
    SDL_Flip(screen);
    bool Q=false;
    int xx,yy;
    while( Q == false )
    {
        //If there's events to handle
        if( SDL_PollEvent( &event ) )
        {
            if( event.type == SDL_QUIT )
            {
                //Quit the program
                Q = true;
                //return false;
            }
            if( event.type == SDL_MOUSEBUTTONDOWN )
            {
                xx = event.button.x;
                yy = event.button.y;
                //Exit Button
            }}}

}
int checkWin(int g[][6][2]) //Checking if the grid contains the ID of only player or not
{
        int champ=0;
        for(int v=0; v<8;v++)
        {
        for(int h =0 ; h<6; h++)
        {
            if(g[v][h][1]!=0)
            {
                if(champ==0)
                {
                    champ = g[v][h][1];
                    //continue;
                }
                else if(champ==g[v][h][1])
                /*continue*/;
                else
                {
                champ=-1;
                break;
                }
            }
        }
        if (champ==-1)
            break;
            }
        return champ;
}

void TurnPrinter(int T) // Turn indicating function prints the ID of the player whose turn it is.
{
    SDL_Surface* Turn = NULL;
    switch(T)
    {
    case 1:
        Turn = load_image("one.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 2:
        Turn = load_image("two.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 3:
        Turn = load_image("three.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 4:
        Turn = load_image("four.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 5:
        Turn = load_image("five.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 6:
        Turn = load_image("six.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);
        break;
    case 7:
        Turn = load_image("comp.png");
        apply_surface(460,140,Turn,screen);
        SDL_Flip(screen);

    }
}

void MoveComp(int M[][6][2],int a , int b, int ID)
{
                if(M[a][b][1]==ID)
                {
                    M[a][b][0] += M[a][b][1];
                    Blast(a,b,M,ID);
                }
                else
                {
                    M[a][b][1] = ID;
                    M[a][b][0] += M[a][b][1];
                    Blast(a,b,M,ID);
                }
}
double FindRatio(int M[][6][2],int sID , int eID)
{
    int s=0,e=0;
    for(int A=0 ; A<8 ; A++)
    {
        for(int B=0; B<6 ; B++)
        {
            if(M[A][B][1]==sID)
                s+=M[A][B][0]/M[A][B][1];
            if(M[A][B][1]==eID)
                e+=M[A][B][0]/M[A][B][1];
        }
    }
    double R=0;
    if(e==0)
        R=142.0;
    else
    R = s/e;
    return R;
}
CompMove Simulate( int GR[][6][2], int enemyID, int selfID)
{
    int Map[8][6][2];
    int ii,jj;
    for(ii = 0 ; ii<8 ; ii++ )
    {
        for(jj=0; jj<6 ; jj++)
        {
            if(GR[ii][jj][1]==1)
            {
                Map[ii][jj][1] = 8;
                Map[ii][jj][0] = Map[ii][jj][0]* 8;
            }
            if(GR[ii][jj][1]==2)
            {
                Map[ii][jj][1] = 7;
                Map[ii][jj][0] = (Map[ii][jj][0]/2)* 7;
            }
        }
    }
    CompMove temp;
    CompMove TheMove;
    //copy array
    for(int i=0; i<8; i++)
    {
        for(int j=0 ; j<6 ; j++)
        {
            if(Map[i][j][1]!=enemyID)
            {
                    MoveComp(Map,i,j,selfID);
                    int PMap[8][6][2];
                    for(ii=0;ii<8;ii++)
                    {
                        for(jj=0;jj<6;j++)
                        {
                            PMap[ii][jj][0] = Map[ii][jj][0];
                            PMap[ii][jj][0] = Map[ii][jj][0];
                        }
                    }
                    int Swap;
                    for(int I=0; I<8 ;I++)
                        {
                            for(int J=0; J<6 ; J++)
                                {
                                    if(PMap[I][J][1]!=selfID)
                                        {
                                            MoveComp(PMap,I,J,enemyID);
                                            double r = FindRatio(PMap,selfID,enemyID);
                                            if (TheMove.Ratio < r)
                                                {
                                                    TheMove.x = j;
                                                    TheMove.y = i;
                                                    TheMove.Ratio = r;
                                                }
                                        }
                            for(ii=0;ii<8;ii++)
                                {
                                    for(jj=0;jj<6;j++)
                                        {
                                            PMap[ii][jj][0] = Map[ii][jj][0];
                                            PMap[ii][jj][0] = Map[ii][jj][0];
                                        }
                                }
                                }
                        }
                }
                for(ii = 0 ; ii<8 ; ii++ )
                    {
                        for(jj=0; jj<6 ; jj++)
                            {
                                if(GR[ii][jj][1]==1)
                                    {
                                        Map[ii][jj][1] = 8;
                                        Map[ii][jj][0] = GR[ii][jj][0] *8;
                                    }
                                if(GR[ii][jj][1]==2)
                                    {
                                        Map[ii][jj][1] = 7;
                                        Map[ii][jj][0] = (Map[ii][jj][0]/2)* 7;
                                    }
                            }
                    }
        }
    }
return TheMove;
}

bool GamePlay(int num)
{
SDL_Surface* behind = load_image("black.bmp");
apply_surface(0,0,behind,screen);
SDL_Flip(screen);
SDL_Surface* Image;
bool Quit = false;
Image = load_image("smallgrid.bmp");
  if(Image==NULL)
        return false;
  for(int i=0;i<480;i=i+60)
    {
        for(int j=0;j<360;j=j+60)
        apply_surface(j,i,Image,screen);
    }
TurnPrinter(1);
SDL_Flip(screen);

    int Grid [8][6][2];
    for(int vv=0; vv<8;vv++)
    {
        for(int hh =0 ; hh<6; hh++)
        {
            Grid[vv][hh][1]=0;
            Grid[vv][hh][0]=0;

        }
    }
    CompMove AImove;
    int firstTurn=1;
    int j=1;
    int X,Y;
    int x,y;
    int track=-1;
    SDL_WM_SetCaption( "CHAIN RxN", NULL );
    while( Quit == false )
    {
        //If there's events to handle
        if( SDL_PollEvent( &event ) )
        {

            //If the user has Xed out the window
            if( event.type == SDL_QUIT )
            {
                //Quit the program
                Quit = true;
                //return false;
            }
             if((num==1)&&(track==0))
                {

                    j = 2;
                    AImove = Simulate(Grid,8,7);
                    X = AImove.x;
                    Y = AImove.y;
                    if((Grid[X][Y][1]!=j)&&(Grid[X][Y][1]!=0))
                        continue;
                    if(Grid[X][Y][1]==j)
                    {
                        Grid[X][Y][0] += Grid[X][Y][1];
                        Blast(X,Y,Grid,j);
                    }
                    else
                    {
                        Grid[X][Y][1] = j;
                        Grid[X][Y][0] += Grid[X][Y][1];
                        Blast(X,Y,Grid,j);
                    }
                    track = -1;
                    j = 1;
                    if(checkWin(Grid)==-1)
                    continue;
                    else
                    {
                        GameOver(7);
                        return true;

                }}

            /*if(event.type == SDL_MOUSEMOTION)
            {
            x = event.motion.x;
            y = event.motion.y;
            if((x<360)||(y<480))
            x = x/60;
            x = x*60;
            y = y/60;
            y = y*60;
            SDL_Surface* highlight = load_image("MouseOver.bmp");
            apply_surface(x,y,highlight,screen);
            Y = x/60;
            X = y/60;
            if(Grid[X][Y][1]!=0)
            BlitBalls(Grid[X][Y][1],Grid[X][Y][0]/Grid[X][Y][1],x,y,Grid);
            SDL_Flip(screen);
            if(((floor(event.motion.x/60)!=Y))||(floor(event.motion.x/60)!=X))
            SDL_FreeSurface(highlight);
            SDL_Flip(screen);
            }*/
            if( event.type == SDL_MOUSEBUTTONDOWN )
            {

                track = 0;
                x = event.button.x;
                y = event.button.y;
                if((x>360)||(y>480))
                    continue;
                x = x/60;
                x = x*60;
                y = y/60;
                y = y*60;
                Y = x/60;
                X = y/60;
                if((Grid[X][Y][1]!=j)&&(Grid[X][Y][1]!=0))
                        continue;
                if(Grid[X][Y][1]==j)
                    {
                        Grid[X][Y][0] += Grid[X][Y][1];
                        Blast(X,Y,Grid,j);
                    }
                else
                    {
                        Grid[X][Y][1] = j;
                        Grid[X][Y][0] += Grid[X][Y][1];
                        Blast(X,Y,Grid,j);
                    }
                if(firstTurn>num)
                    {
                        int winID = checkWin(Grid);
                        if(winID==-1)
                            {
                                j++;
                                if((num==1)&&(j>2))
                                j=1;
                                else
                                {
                                if(j>num)
                                j=1;
                                }
                                firstTurn++;
                                if(((!checkPlayerExist(j,Grid))&&(firstTurn>num)))
                                    {
                                        j++;
                                        if(j>num)
                                        j=1;
                                    }
                                TurnPrinter(j);
                                continue;
                            }
                        else
                            {
                                GameOver(winID);

                            }
                    }
                else
                    {
                        if(num==1)
                            {
                                firstTurn++;
                                //TurnPrinter((track==-1)?1:7);

                            }
                        else
                        {
                        j++;
                        if(j>num)
                        j=1;
                        firstTurn++;
                        TurnPrinter(j);
                        }
                    }
               SDL_Flip(screen);
            }
        }
    }
    return true;
}
int MainScreen()
{
    bool quitMS=false;
    int xMS=0,yMS=0;
    //Load the image
    MainScr = load_image( "Main.bmp" );
    //If there was a problem in loading the button sprite sheet
    if( MainScr == NULL )
    {
        return -1;
    }
    apply_surface(0,0,MainScr,screen);
    if( SDL_Flip( screen ) == -1 )
        {
            return -1;
        }
    while( quitMS == false )
    {
        //If there's events to handle
        if( SDL_PollEvent( &event ) )
        {
            //If the user has Xed out the window
            if( event.type == SDL_QUIT )
            {
                //Quit the program
                quitMS = true;
                //return false;
            }
            if( event.type == SDL_MOUSEBUTTONDOWN )
            {
            //Get the mouse offsets
            xMS = event.button.x;
            yMS = event.button.y;

            //return 0 for PLay
            if((yMS>=255)&&(yMS<330))
                return 0;
            else if((yMS>=330)&&(yMS<405))
               return 1;
            else if((yMS>=405)&&(yMS<480))
                return 3;
            }

        }}


    //If everything loaded fine
    return 0;
}

int NumberOfPlayer() //Flashes the grid from which we can select the number of players
{
    SDL_FreeSurface(MainScr);
    bool quitNOP=false;
    int xNOP=0,yNOP=0;
    //Load the image
    NumPlayers = load_image( "NP.bmp" );
    //If there was a problem in loading the button sprite sheet
    if( NumPlayers == NULL )
    {
        return -1;
    }
    apply_surface(0,0,NumPlayers,screen);
    if( SDL_Flip( screen ) == -1 )
        {
            return -1;
        }
     while( quitNOP == false )
    {
        //If there's events to handle
        if( SDL_PollEvent( &event ) )
        {
            if( event.type == SDL_MOUSEBUTTONDOWN )
            {
                if( event.type == SDL_QUIT )
            {
                //Quit the program
                quitNOP = true;
                return -1;
            }
            if( event.button.button == SDL_BUTTON_LEFT )
            {
            //Get the mouse offsets
            xNOP = event.button.x;
            yNOP = event.button.y;

            struct Choice
                {
                    int startX;
                    int startY;
                    int width = 80;
                    int height = 50;
                };
                int ch=0;
                Choice choices[6];
                for(int ini = 0; ini<6 ; ini++)
                {
                 choices[ini].startX = 200 + (ini%3)*80;
                 choices[ini].startY = 300 + floor(ini/3)*50;
                }
                for(ch=0; ch<6 ; ch++)
                {
                    if((xNOP > choices[ch].startX)&&(xNOP < choices[ch].startX+choices[ch].width)&&(yNOP > choices[ch].startY)&& (yNOP < choices[ch].startY + choices[ch].height ))
                    {
                        if(ch!=0)
                        return ch+1;
                    }
                    else
                        continue;
                }


            }}
            //If the user has Xed out the window
        }}


    //If everything loaded fine
    return 0;
}

class StringInput
{
    public:
    //The storage string
    std::string str;

    //The text surface
    SDL_Surface *text;

    public:
    //Initializes variables
    StringInput();

    //Does clean up
    ~StringInput();

    //Handles input
    void handle_input();

    //Shows the message on screen
    void show_centered();
};

StringInput::StringInput()
{
    //Initialize the string
    str = "";

    //Initialize the surface
    text = NULL;

    //Enable Unicode
    SDL_EnableUNICODE( SDL_ENABLE );
}

StringInput::~StringInput()
{
    //Free text surface
    SDL_FreeSurface( text );

    //Disable Unicode
    SDL_EnableUNICODE( SDL_DISABLE );
}

void StringInput::handle_input()
{
    //If a key was pressed
    if( event.type == SDL_KEYDOWN )
    {
        //Keep a copy of the current version of the string
        std::string temp = str;

        //If the string less than maximum size
        if( str.length() <= 16 )
        {
            //If the key is a space
            if( event.key.keysym.unicode == (Uint16)' ' )
            {
                //Append the character
                str += (char)event.key.keysym.unicode;
            }
            //If the key is a number
            else if( ( event.key.keysym.unicode >= (Uint16)'0' ) && ( event.key.keysym.unicode <= (Uint16)'9' ) )
            {
                //Append the character
                str += (char)event.key.keysym.unicode;
            }
            //If the key is a uppercase letter
            else if( ( event.key.keysym.unicode >= (Uint16)'A' ) && ( event.key.keysym.unicode <= (Uint16)'Z' ) )
            {
                //Append the character
                str += (char)event.key.keysym.unicode;
            }
            //If the key is a lowercase letter
            else if( ( event.key.keysym.unicode >= (Uint16)'a' ) && ( event.key.keysym.unicode <= (Uint16)'z' ) )
            {
                //Append the character
                str += (char)event.key.keysym.unicode;
            }
        }

        //If backspace was pressed and the string isn't blank
        if( ( event.key.keysym.sym == SDLK_BACKSPACE ) && ( str.length() != 0 ) )
        {
            //Remove a character from the end
            str.erase( str.length() - 1 );
        }

        //If the string was changed
        if( str != temp )
        {
            //Free the old surface
            SDL_FreeSurface( text );

            //Render a new text surface
            text = TTF_RenderText_Solid( font, str.c_str(), textColor );
        }
    }
}

void StringInput::show_centered()
{
    //If the surface isn't blank
    if( text != NULL )
    {
        //Show the name
        apply_surface( ( SCREEN_WIDTH - text->w ) / 2, ( SCREEN_HEIGHT - text->h ) / 2, text, screen );
    }
}

bool PlayerDetails(int num)
{
    SDL_FreeSurface(NumPlayers);
    SDL_WM_SetCaption( "Player Details", NULL );
    char* Names = new char[16*num];
    SDL_Surface* BackgroundInput = load_image("BckIn.png");
    if( BackgroundInput == NULL )
    {
        return false;//false;
    }
    apply_surface(0,0,BackgroundInput,screen);
    SDL_Flip(screen);
    bool nameEntered = false;
    bool quitPD = false;
    if( TTF_Init() == -1 )
    {
        return false;// false;
    }
    StringInput name;
    int counter = 0;
    //Open the font
    font = TTF_OpenFont( "lazy.ttf", 42 );
    if( font == NULL )
    {
        return false;
    }
     message = TTF_RenderText_Solid( font, "Enter name for plyaer 1 :", textColor );
    while( quitPD == false )
    {
        //While there's events to handle
        while( SDL_PollEvent( &event ) )
        {
            //If the user has Xed out the window
            if( event.type == SDL_QUIT )
            {
                //Quit the program
                quitPD = true;
            }
            //If the user hasn't entered their name yet
            if( nameEntered == false )
            {
                //Get user input
                name.handle_input();

                //If the enter key was pressed
                if( ( event.type == SDL_KEYDOWN ) && ( event.key.keysym.sym == SDLK_RETURN ) )
                {
                    //Change the flag
                    //nameEntered = true;

                    //Free the old message surface
                    SDL_FreeSurface( message );
                    SDL_FreeSurface(name.text);
                    name.text = NULL;
                    for(int lv = 0 ; lv < num ; lv++)
                    {
                        Names[(16*counter)+lv] = name.str[lv];
                    }
                    name.str="";
                    counter++;
                    //Change the message
                    char s[23] = "Enter name for player ";
                    s[23] = counter+1;
                    message = TTF_RenderText_Solid( font, s , textColor );
                    if (counter==num)
                        {
                            nameEntered=true;
                            SDL_FreeSurface(BackgroundInput);
                            SDL_FreeSurface(message);
                            return false;
                        }
                }
            }

apply_surface( ( SCREEN_WIDTH - message->w ) / 2, ( ( SCREEN_HEIGHT / 2 ) - message->h ) / 2, message, screen );
 if( SDL_Flip( screen ) == -1 )
        {
            return false;// 1;
        }
        }
}
return false;
}
bool HowToPlay()// Flashes a short paragraph on how to play the game
{
    SDL_Surface* H2P = load_image("H2P.bmp");
    apply_surface(0,0,H2P,screen);
    SDL_Flip(screen);
    int xH2P,yH2P;
    bool quitH2P;
    while( quitH2P == false )
    {
        //If there's events to handle
        if( SDL_PollEvent( &event ) )
        {
            //If the user has Xed out the window
            if( event.type == SDL_QUIT )
            {
                //Quit the program
                quitH2P = true;
                //return false;
            }
            if( event.type == SDL_MOUSEBUTTONDOWN )
            {
            //Get the mouse offsets
            xH2P = event.button.x;
            yH2P = event.button.y;

            //return 0 for PLay
            if(yH2P>405)
                return true;

        }}
    }
    return true;
    }

int main( int argc, char* args[] )
{

    int numP=0;
    if(init()==false)
        return -1;
    //while
    bool var = true;
    for(;var;)
    {
    switch(MainScreen())
    {
    case -1:
        return 11;
    case 0:
        numP = NumberOfPlayer();
        if(numP==-1)
            return 22;
        //if(!PlayerDetails(numP));
          // return 33;
        if(!GamePlay(numP))
           return 44;
        else
        var = true;
        break;
    case 1:
        var = HowToPlay();
        break;
    case 2:
        //var = PrevResults();
        break;
    case 3:
        return 12345;
        break;
    }
    }
    return 0;
}



